package dk.aau.cs.model.tapn.Colored;

import dk.aau.cs.model.tapn.Colored.Expressions.ArcExpression;
import dk.aau.cs.model.tapn.TimeInterval;
import dk.aau.cs.model.tapn.TimedInputArc;
import dk.aau.cs.model.tapn.TimedPlace;
import dk.aau.cs.model.tapn.TimedTransition;

import java.util.ArrayList;
import java.util.List;

public class ColoredInputArc extends TimedInputArc {

    private ArcExpression expression;
    List<ColoredTimeInterval> colorTimeIntervals = new ArrayList<ColoredTimeInterval>() {{
        add(ColoredTimeInterval.ZERO_INF_DYN_COLOR(Color.STAR_COLOR));
    }};

    public ColoredInputArc(TimedPlace source, TimedTransition destination, TimeInterval interval, ArcExpression expression) {
        super(source, destination, interval);
        this.expression = expression;
    }

    public List<ColoredTimeInterval> getColorTimeIntervals() {
        return colorTimeIntervals;
    }

    public void setColorTimeIntervals(List<ColoredTimeInterval> colorTimeIntervals) {
        this.colorTimeIntervals = colorTimeIntervals;
    }

    public void replaceColorTimeInterval(ColoredTimeInterval cti) {
        for (int i = 0; i < colorTimeIntervals.size(); i++) {
            if (colorTimeIntervals.get(i).equals(cti)) {
                colorTimeIntervals.set(i, cti);
            }
        }
    }

    public ArcExpression getArcExpression() {return this.expression;}


    public void setExpression(ArcExpression expression) {this.expression = expression;}

}
