package dk.aau.cs.model.tapn.Colored;

import dk.aau.cs.model.tapn.Bound;
import dk.aau.cs.model.tapn.TimeInvariant;

public class ColoredTimeInvariant extends TimeInvariant {
    private Color color;
    private static final DotConstant dotConstant = new DotConstant();
    public static final ColoredTimeInvariant LESS_THAN_INFINITY_AND_DOT = new ColoredTimeInvariant(false, Bound.Infinity, dotConstant);
    public static final ColoredTimeInvariant LESS_THAN_INFINITY_AND_STAR = new ColoredTimeInvariant(false, Bound.Infinity, new Color(new ColorType("*"), 0, "*"));

    public ColoredTimeInvariant(boolean isUpperIncluded, Bound upper, Color color) {
        super(isUpperIncluded, upper);
        this.color = color;
    }

    public static final ColoredTimeInvariant LESS_THAN_INFINITY_DYN_COLOR(Color color) {
        return new ColoredTimeInvariant(false, Bound.Infinity, color);
    }

    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    @Override
    public String toString() {
        if (color.getTuple() != null)
            return color.getTuple().toString() + " " + super.toString();
        else
            return color.toString() + " " + super.toString();
    }

    @Override
    public boolean equals(Object o) {
        ColoredTimeInvariant cti;
        if (!(o instanceof ColoredTimeInvariant))
            return false;
        else
            cti = (ColoredTimeInvariant) o;

        if (!cti.color.equals(this.color))
            return false;
        if (!(cti.isUpperNonstrict() == this.isUpperNonstrict()))
            return false;
        if (!(cti.upperBound().value() == this.upperBound().value()))
            return false;
        return true;
    }

    @Override
    public int hashCode() {
        int result = 17;
        result = 31 * result + upperBound().hashCode();
        result = 31 * result + color.hashCode();
        return result;
    }
}
